blob: 09a1b13a6094464b7a27ebff3382d7cfba3f297d [file] [log] [blame]
Benedikt Böhme2fa4912010-01-26 14:41:20 +01001#!/bin/sh
Benedikt Böhm00ccea62010-01-26 12:39:36 +01002#
Vincent Driessen6c2d30b2010-01-26 22:18:36 +01003# git-flow -- A collection of Git extensions to provide high-level
4# repository operations for Vincent Driessen's branching model.
Benedikt Böhm00ccea62010-01-26 12:39:36 +01005#
6# Original blog post presenting this model is found at:
7# http://nvie.com/archives/323
8#
9# Feel free to contribute to this project at:
10# http://github.com/nvie/gitflow
11#
12# Copyright (c) 2010 by Vincent Driessen
13# Copyright (c) 2010 by Benedikt Böhm
14#
15
Benedikt Böhme5eaff92010-01-26 12:44:55 +010016# enable debug mode
17if [ "$DEBUG" = "yes" ]; then
18 set -x
19fi
20
Benedikt Böhm4a864fb2010-01-26 12:59:27 +010021export GITFLOW_DIR=$(dirname "$0")
22export MASTER_BRANCH=$(git config --get gitflow.branch.master || echo master)
23export DEVELOP_BRANCH=$(git config --get gitflow.branch.develop || echo develop)
Benedikt Böhm350e7152010-01-26 13:05:05 +010024export ORIGIN=$(git config --get gitflow.origin || echo origin)
Benedikt Böhm427c5db2010-01-26 18:23:44 +010025export README=$(git config --get gitflow.readme || echo README)
Benedikt Böhm4a864fb2010-01-26 12:59:27 +010026
Benedikt Böhm00ccea62010-01-26 12:39:36 +010027warn() { echo "$@" >&2; }
28die() { warn "$@"; exit 1; }
Benedikt Böhme2fa4912010-01-26 14:41:20 +010029
30has() {
31 local item=$1; shift
32 echo " $@ " | grep -q " $item "
33}
Benedikt Böhm00ccea62010-01-26 12:39:36 +010034
35usage() {
Benedikt Böhm7d703a82010-01-26 13:17:12 +010036 . "$GITFLOW_DIR/git-flow-version"
Vincent Driessen6c2d30b2010-01-26 22:18:36 +010037 echo "git-flow, version $GITFLOW_VERSION"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010038 echo
Vincent Driessen186d2b52010-01-27 23:48:39 +010039 echo "usage: git flow <subcommand>"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010040 echo
Vincent Driessen186d2b52010-01-27 23:48:39 +010041 echo "Available subcommands are:"
42 echo " init Initialize a new git repo with support for the branching model."
43 echo " feature Manage your feature branches."
44 echo " release Manage your release branches."
45 echo " hotfix Manage your hotfix branches."
46 echo " support Manage your support branches."
Benedikt Böhm7d703a82010-01-26 13:17:12 +010047 echo
Vincent Driessen186d2b52010-01-27 23:48:39 +010048 echo "Try 'git flow <subcommand> help' for details."
Benedikt Böhm00ccea62010-01-26 12:39:36 +010049}
50
51main() {
Benedikt Böhm427c5db2010-01-26 18:23:44 +010052 if [ $# -lt 1 ]; then
Benedikt Böhm00ccea62010-01-26 12:39:36 +010053 usage
54 exit 1
55 fi
56
Benedikt Böhm00ccea62010-01-26 12:39:36 +010057 # sanity checks
Vincent Driessen186d2b52010-01-27 23:48:39 +010058 SUBCOMMAND="$1"; shift
Benedikt Böhm427c5db2010-01-26 18:23:44 +010059
Vincent Driessen186d2b52010-01-27 23:48:39 +010060 if [ ! -e "$GITFLOW_DIR/git-flow-$SUBCOMMAND" ]; then
Benedikt Böhm00ccea62010-01-26 12:39:36 +010061 usage
62 exit 1
63 fi
64
Vincent Driessen2ba9a4d2010-01-27 12:51:07 +010065 if ! git rev-parse --git-dir >/dev/null; then
Benedikt Böhm00ccea62010-01-26 12:39:36 +010066 die "Not a git repository"
67 fi
68
69 # get all available branches
70 LOCAL_BRANCHES=$(git branch | sed 's/^[* ] //')
71 REMOTE_BRANCHES=$(git branch -r | sed 's/^[* ] //')
72 ALL_BRANCHES="$LOCAL_BRANCHES $REMOTE_BRANCHES"
73
74 # run command
Vincent Driessen186d2b52010-01-27 23:48:39 +010075 . "$GITFLOW_DIR/git-flow-$SUBCOMMAND"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010076
Vincent Driessen186d2b52010-01-27 23:48:39 +010077 if ! typeset -f sub_main >/dev/null; then
Benedikt Böhm00ccea62010-01-26 12:39:36 +010078 usage
79 exit 1
80 fi
81
Benedikt Böhm00ccea62010-01-26 12:39:36 +010082 # run command
Vincent Driessen186d2b52010-01-27 23:48:39 +010083 sub_main "$@"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010084}
85
Vincent Driessen186d2b52010-01-27 23:48:39 +010086sub_main() {
87 SUBACTION="${1:-default}"; shift
88 if ! typeset -f cmd_$SUBACTION 2>&1 >/dev/null; then
89 warn "Unknown subcommand: '$1'"
90 usage
91 exit 1
Benedikt Böhm427c5db2010-01-26 18:23:44 +010092 fi
93
Vincent Driessen186d2b52010-01-27 23:48:39 +010094 # run the specified action
95 cmd_$SUBACTION "$@"
Benedikt Böhm427c5db2010-01-26 18:23:44 +010096}
97
Benedikt Böhm00ccea62010-01-26 12:39:36 +010098gitflow_check_clean_working_tree() {
99 if ! git diff --no-ext-diff --ignore-submodules --quiet --exit-code; then
100 die "Working tree contains unstaged changes. Aborting ..."
101 fi
102 if ! git diff-index --cached --quiet --ignore-submodules HEAD --; then
103 die "Index contains uncommited changes. Aborting ..."
104 fi
105}
106
107gitflow_require_local_branch() {
108 if ! has $1 $LOCAL_BRANCHES; then
109 die "Local branch '$1' does not exist and is required."
110 fi
111}
112
113gitflow_require_remote_branch() {
114 if ! has $1 $REMOTE_BRANCHES; then
115 die "Remote branch '$1' does not exist and is required."
116 fi
117}
118
119gitflow_require_branch() {
120 if ! has $1 $ALL_BRANCHES; then
121 die "Branch '$1' does not exist and is required."
122 fi
123}
124
125gitflow_require_branch_absent() {
126 if has $1 $ALL_BRANCHES; then
127 die "Branch '$1' already exists. Pick another name."
128 fi
129}
130
131#
132# gitflow_test_branches_equal()
133#
134# Tests whether branches and their "origin" counterparts have diverged and need
135# merging first. It returns error codes to provide more detail, like so:
136#
137# 0 Branch heads point to the same commit
138# 1 First given branch needs fast-forwarding
139# 2 Second given branch needs fast-forwarding
140# 3 Branch needs a real merge
141#
142gitflow_test_branches_equal() {
143 commit1=$(git rev-parse "$1")
144 commit2=$(git rev-parse "$2")
145 if [ "$commit1" != "$commit2" ]; then
146 base=$(git merge-base "$commit1" "$commit2")
147 if [ "$commit1" = "$base" ]; then
148 return 1
149 elif [ "$commit2" = "$base" ]; then
150 return 2
151 else
152 return 3
153 fi
154 else
155 return 0
156 fi
157}
158
159gitflow_require_branches_equal() {
160 gitflow_require_local_branch "$1"
161 gitflow_require_remote_branch "$2"
162 gitflow_test_branches_equal "$1" "$2"
163 status=$?
164 if [ $status -gt 0 ]; then
165 warn "Branches '$1' and '$2' have diverged."
166 if [ $status -eq 1 ]; then
167 die "And branch '$1' may be fast-forwarded."
168 elif [ $status -eq 2 ]; then
169 # Warn here, since there is no harm in being ahead
170 warn "And local branch '$1' is ahead of '$2'."
171 else
172 die "Branches need merging first."
173 fi
174 fi
175}
176
177main "$@"